var listenOpen = {
   observe : function(aSubject, aTopic) {
    if(aTopic!="domwindowopened")
      return;
    aSubject.addEventListener("load", function(mEvent) { doIt(aSubject);}, false);
  }
};

var myMenu = {
		"Default User Agent" : "",
		"Internet Explorer" : {
			"9" : "Mozilla/4.0 (compatible; MSIE 9.0; Windows NT 6.1)",
			"8" : "Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 6.1)",	
			"7" : "Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 6.0)",
			"6" : "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)" 
		},
		"Firefox" : {
			"10"   : "Mozilla/5.0 (compatible; rv:1.9b4) Gecko/2012010317 Firefox/10.0a4",
			"9"   : "Mozilla/5.0 (compatible; rv:9.0) Gecko/20110101 Firefox/9.0",
			"6"   : "Mozilla/5.0 (compatible; rv:6.0) Gecko/20110101 Firefox/6.0",
			"5"   : "Mozilla/5.0 (compatible; rv:5.0) Gecko/20110101 Firefox/5.0",
			"4"   : "Mozilla/5.0 (compatible; rv:2.0) Gecko/20110101 Firefox/4.0",
			"3.6" : "Mozilla/5.0 (compatible; rv:1.9.2) Gecko/20100101 Firefox/3.6",
			"3.5" : "Mozilla/5.0 (compatible; rv:1.9.1) Gecko/20090702 Firefox/3.5",
			"3"   : "Mozilla/5.0 (compatible; rv:1.9) Gecko/20080101 Firefox/3.0",
			"2"   : "Mozilla/5.0 (compatible; rv:1.8.1) Gecko/20070101 Firefox/2.0",
			"1.5" : "Mozilla/5.0 (compatible; rv:1.8) Gecko/20060101 Firefox/3.0",
			"Fennec 4.0" : "Mozilla/5.0 (Android; Linux armv7l; rv:2.0) Gecko/20110103 Firefox/4.0 Fennec/4.0",
		},
		"Chrome" : {
			"11" : "Mozilla/5.0 (compatible) AppleWebKit/534.21 (KHTML, like Gecko) Chrome/11.0.682.0 Safari/534.21",
			"10" : "Mozilla/5.0 (compatible) AppleWebKit/534.14 (KHTML, like Gecko) Chrome/10.0.602.0 Safari/534.14",
			"9"  : "Mozilla/5.0 (compatible) AppleWebKit/534.14 (KHTML,like Gecko) Chrome/9.0.0.0 Safari/534.14",
			"8"  : "Mozilla/5.0 (compatible) AppleWebKit/534.14 (KHTML,like Gecko) Chrome/8.0.558.0 Safari/534.14",
			"7"  : "Mozilla/5.0 (compatible) AppleWebKit/534.10 (KHTML,like Gecko) Chrome/7.0.540.0 Safari/534.10",
			"6"  : "Mozilla/5.0 (compatible) AppleWebKit/534.1 (KHTML,like Gecko) Chrome/6.0.481.0 Safari/534.1",
			"5"  : "Mozilla/5.0 (compatible) AppleWebKit/533.2 (KHTML,like Gecko) Chrome/5.0.342.0 Safari/533.2"
		},
		"Safari" : {
			"5" : "Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10_7) AppleWebKit/534.16+ (KHTML, like Gecko) Version/5.0.3 Safari/533.19.4",
			"4" : "Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10_5_7) AppleWebKit/531.2+ (KHTML, like Gecko) Version/4.0.1 Safari/530.18",
			"3" : "Mozilla/5.0 (Macintosh; U; PPC Mac OS X) AppleWebKit/412.7 (KHTML, like Gecko) Safari/412.5"
		},
		"Opera" : {
			"11" :  "Opera/9.80 (compatible; U) Presto/2.7.39 Version/11.00",
			"10" :  "Opera/9.80 (compatible; U) Presto/2.2.15 Version/10.00",
			"9"  :  "Opera/9.70 (compatible; U) Presto/2.2.0",
			"8"  :  "Opera/8.02 (compatible; U)",
			"Mini" : "Opera/9.60 (J2ME/MIDP; Opera Mini/4.2.13918/670; U) Presto/2.2.0",
			"Mobile" : "Opera/9.80 (S60; SymbOS; Opera Mobi/499; U) Presto/2.4.18 Version/10.00"
		},
		"Maxthon" : {
			"3" :  "Mozilla/5.0 (compatible; U) AppleWebKit/533.1 (KHTML, like Gecko) Maxthon/3.0.8.2 Safari/533.1",
			"2" :  "Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 5.2; Trident/4.0; MAXTHON 2.0)"
		},
		"iPhone" : "Mozilla/5.0 (iPhone; U; CPU OS 4_2_1 like Mac OS X) AppleWebKit/532.9 (KHTML, like Gecko) Version/5.0.3 Mobile/8B5097d Safari/6531.22.7",
		"iPad" : "Mozilla/5.0 (iPad; U; CPU OS 4_2_1 like Mac OS X) AppleWebKit/533.17.9 (KHTML, like Gecko) Version/4.0.2 Mobile/8C148 Safari/6533.18.5",
		"Android" : "Mozilla/5.0 (Linux; U; Android 2.2) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1",
		"Other" : {
			"Kindle" : "Mozilla/4.0 (compatible; Linux 2.6.22) NetFront/3.4 Kindle/2.0 (screen 600x800)",
			"Nintendo Wii" : "Opera/9.30 (Nintendo Wii; U; ; 2047-7; en)",
			"Playstation 3" : "Mozilla/5.0 (PLAYSTATION 3; 3.55)",
		},
		"Search Robots" : {
			"Googlebot 2.1" :  "Mozilla/5.0 (compatible; Googlebot/2.1; +http://www.google.com/bot.html)",
			"Msnbot 1.1" :  "msnbot/1.1 (+http://search.msn.com/msnbot.htm)",
			"Yahoo Slurp" :  "Mozilla/5.0 (compatible; Yahoo! Slurp; http://help.yahoo.com/help/us/ysearch/slurp)"
		}
};

var watcher = Components.classes["@mozilla.org/embedcomp/window-watcher;1"]  
                         .getService(Components.interfaces.nsIWindowWatcher);
						 
function install() {};
function uninstall() {};

function startup(data, reason) {
  watcher.registerNotification(listenOpen);
  var mWindows = watcher.getWindowEnumerator();
  while (mWindows.hasMoreElements()) {
     doIt(mWindows.getNext());
  }
};

function shutdown(data, reason) {
  superUserAgent("");
  watcher.unregisterNotification(listenOpen);
  var mWindows = watcher.getWindowEnumerator();
  while (mWindows.hasMoreElements()) {
     undoIt(mWindows.getNext());
  }
};

function doIt(aWindow) {
	try{
		aDocument = aWindow.document;
		addTheMenu(aWindow);
		aWindow.superUserAgent = superUserAgent;
		aWindow.superParseRadio = superParseRadio;
	} catch(e) {}
};

function undoIt(aWindow) {
	try{
		mMenu = aWindow.document.getElementById('superMenu');
		mMenu.parentNode.removeChild(mMenu);
		aWindow.superUserAgent = null;
		aWindow.superParseRadio = null;
	} catch(e) {}
};

var aDocument;

function addTheMenu(aWindow) {
		var devToolsLine = aDocument.getElementById('devToolsSeparator');
		if(!devToolsLine)
			return;
		var aMenu = parseMenu();
		aMenu.setAttribute("id", "superMenu");
		var onpopupshowing = <><![CDATA[
			if (event.target != this)
				return true;
			superParseRadio(event.target);
			return true;
		]]></>.toString();
		aMenu.firstChild.setAttribute("onpopupshowing", onpopupshowing);
		devToolsLine.parentNode.insertBefore(aMenu, devToolsLine.nextSibling);
};

function superParseRadio(mMenu) {
	try{
		var currentAgent = "";
		try {
		currentAgent = Components.classes["@mozilla.org/preferences-service;1"]
	                  .getService(Components.interfaces.nsIPrefService)
										.getBranch("general.useragent.")
										.getCharPref("override");
		} catch(e) {}
		var nodes = mMenu.getElementsByTagName("menuitem");
		for(i in nodes) { try{
			if(nodes[i] instanceof Components.interfaces.nsIDOMXULElement) {
				mItem = nodes[i];
				if(currentAgent==nodes[i].agentString) {
					mItem.setAttribute("type","radio");
					mItem.setAttribute("checked","true");
				} else {
					mItem.removeAttribute("checked");
				}
			}
		} catch(e) {} }
	} catch(e) {}
};

function superUserAgent(aString) {
	try{
		var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                    .getService(Components.interfaces.nsIPrefService)
										.getBranch("general.useragent.");
		if(aString!="") {
	 	 	prefs.setCharPref("override",aString);
		} else {
	 	 	prefs.clearUserPref("override");
		}
	} catch(e) {}
};

function parseMenu(aLabel, aMember) {
	if(typeof(aMember)=="string") {
		var mItem = aDocument.createElement("menuitem");
		mItem.setAttribute("label", aLabel);
		mItem.label = aLabel;
		mItem.setAttribute("oncommand", "superUserAgent(\"" + aMember + "\");");
		mItem.agentString = aMember;
		return mItem;
	}
	if(typeof(aMember)=="object") {
		var mMenu = aDocument.createElement("menu");
		mMenu.setAttribute("label", aLabel);
		var mSub = aDocument.createElement("menupopup");
		mMenu.appendChild(mSub);
		for(i in aMember) {
			mSub.appendChild(parseMenu(i, aMember[i]));			
		}
		return mMenu;
	}
	if(!aLabel) {
		return parseMenu("Super User Agent", myMenu);
	}
};